-- Do not manually edit this file, it was auto-generated by dillonkearns/elm-graphql
-- https://github.com/dillonkearns/elm-graphql


module UsersApi.Mutation exposing (..)

import CustomScalarCodecs
import Graphql.Internal.Builder.Argument as Argument exposing (Argument)
import Graphql.Internal.Builder.Object as Object
import Graphql.Internal.Encode as Encode exposing (Value)
import Graphql.Operation exposing (RootMutation, RootQuery, RootSubscription)
import Graphql.OptionalArgument exposing (OptionalArgument(..))
import Graphql.SelectionSet exposing (SelectionSet)
import Json.Decode as Decode exposing (Decoder)
import UsersApi.InputObject
import UsersApi.Interface
import UsersApi.Object
import UsersApi.Scalar
import UsersApi.Union


type alias CreateRequiredArguments =
    { user : UsersApi.InputObject.NewUser }


create : CreateRequiredArguments -> SelectionSet decodesTo UsersApi.Object.User -> SelectionSet decodesTo RootMutation
create requiredArgs object_ =
    Object.selectionForCompositeField "create" [ Argument.required "user" requiredArgs.user UsersApi.InputObject.encodeNewUser ] object_ identity


type alias UpdateRequiredArguments =
    { id : CustomScalarCodecs.UserId
    , user : UsersApi.InputObject.PartialUser
    }


update : UpdateRequiredArguments -> SelectionSet decodesTo UsersApi.Object.User -> SelectionSet decodesTo RootMutation
update requiredArgs object_ =
    Object.selectionForCompositeField "update" [ Argument.required "id" requiredArgs.id (CustomScalarCodecs.codecs |> UsersApi.Scalar.unwrapEncoder .codecUserId), Argument.required "user" requiredArgs.user UsersApi.InputObject.encodePartialUser ] object_ identity


type alias DeleteRequiredArguments =
    { id : CustomScalarCodecs.UserId }


delete : DeleteRequiredArguments -> SelectionSet decodesTo UsersApi.Object.User -> SelectionSet decodesTo RootMutation
delete requiredArgs object_ =
    Object.selectionForCompositeField "delete" [ Argument.required "id" requiredArgs.id (CustomScalarCodecs.codecs |> UsersApi.Scalar.unwrapEncoder .codecUserId) ] object_ identity
